Home | History | Annotate | Line # | Download | only in kdc
      1 #!/bin/sh
      2 #
      3 # Copyright (c) 2006 - 2011 Kungliga Tekniska Hgskolan
      4 # (Royal Institute of Technology, Stockholm, Sweden). 
      5 # All rights reserved. 
      6 #
      7 # Redistribution and use in source and binary forms, with or without 
      8 # modification, are permitted provided that the following conditions 
      9 # are met: 
     10 #
     11 # 1. Redistributions of source code must retain the above copyright 
     12 #    notice, this list of conditions and the following disclaimer. 
     13 #
     14 # 2. Redistributions in binary form must reproduce the above copyright 
     15 #    notice, this list of conditions and the following disclaimer in the 
     16 #    documentation and/or other materials provided with the distribution. 
     17 #
     18 # 3. Neither the name of the Institute nor the names of its contributors 
     19 #    may be used to endorse or promote products derived from this software 
     20 #    without specific prior written permission. 
     21 #
     22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND 
     23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
     24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
     25 # ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE 
     26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
     27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
     28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
     29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
     30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
     31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
     32 # SUCH DAMAGE. 
     33 
     34 top_builddir="@top_builddir@"
     35 env_setup="@env_setup@"
     36 objdir="@objdir@"
     37 
     38 . ${env_setup}
     39 
     40 KRB5_CONFIG="${1-${objdir}/krb5.conf}"
     41 export KRB5_CONFIG
     42 
     43 testfailed="echo test failed; cat messages.log; exit 1"
     44 
     45 # If there is no useful db support compiled in, disable test
     46 ${have_db} || exit 77
     47 
     48 R=TEST.H5L.SE
     49 
     50 port=@port@
     51 
     52 kadmin="${kadmin} -l -r $R"
     53 kdc="${kdc} --addresses=localhost -P $port"
     54 
     55 server=host/datan.test.h5l.se
     56 cache="FILE:${objdir}/cache.krb5"
     57 acache="FILE:${objdir}/acache.krb5"
     58 
     59 kinit="${kinit} -c $cache ${afs_no_afslog}"
     60 akinit="${kinit} -c $acache ${afs_no_afslog}"
     61 klist="${klist} -c $cache"
     62 aklist="${klist} -c $acache"
     63 kgetcred="${kgetcred} -c $cache"
     64 kdestroy="${kdestroy} -c $cache ${afs_no_unlog}"
     65 
     66 rm -f ${keytabfile}
     67 rm -f current-db*
     68 rm -f out-*
     69 rm -f mkey.file*
     70 
     71 > messages.log
     72 
     73 echo Creating database
     74 ${kadmin} \
     75     init \
     76     --realm-max-ticket-life=1day \
     77     --realm-max-renewable-life=1month \
     78     ${R} || exit 1
     79 
     80 ${kadmin} add -p foo --use-defaults foo@${R} || exit 1
     81 ${kadmin} add -p foo --use-defaults ${server}@${R} || exit 1
     82 
     83 echo "Doing database check"
     84 ${kadmin} check ${R} || exit 1
     85 
     86 echo foo > ${objdir}/foopassword
     87 echo bar > ${objdir}/barpassword
     88 
     89 echo Starting kdc ; > messages.log
     90 env MallocStackLogging=1 MallocStackLoggingNoCompact=1 MallocErrorAbort=1 MallocLogFile=${objdir}/malloc-log \
     91 ${kdc} --detach --testing || { echo "kdc failed to start"; exit 1; }
     92 kdcpid=`getpid kdc`
     93 
     94 trap "kill -9 ${kdcpid}; echo signal killing kdc; cat messages.log; exit 1;" EXIT
     95 
     96 ec=0
     97 
     98 #
     99 # Check armor ticket
    100 #
    101 
    102 echo "Getting client initial tickets"; > messages.log
    103 ${kinit} --password-file=${objdir}/foopassword foo@$R || \
    104 	{ ec=1 ; eval "${testfailed}"; }
    105 echo "Checking for FAST avail"
    106 ${klist} --hidden | grep fast_avail > /dev/null || { exit 1; }
    107 echo "Getting tickets"; > messages.log
    108 ${kgetcred} ${server}@${R} || { ec=1 ; eval "${testfailed}"; }
    109 echo "Listing tickets"; > messages.log
    110 ${klist} > /dev/null || { ec=1 ; eval "${testfailed}"; }
    111 ${kdestroy}
    112 
    113 echo "Acquire host ticket to be used as an ARMOR ticket"; > messages.log
    114 ${akinit} --password-file=${objdir}/foopassword ${server}@${R} >/dev/null|| { exit 1; }
    115 echo "Checking for FAST avail (in the FAST armor cache)"; > messages.log
    116 ${aklist} --hidden | grep fast_avail > /dev/null || { exit 1; }
    117 
    118 #
    119 # Client tests
    120 #
    121 
    122 echo "Getting client initial tickets with FAST armor ticket"; > messages.log
    123 ${kinit} --fast-armor-cache=${acache} \
    124    --password-file=${objdir}/foopassword foo@$R || \
    125 	{ ec=1 ; eval "${testfailed}"; }
    126 
    127 echo "Getting client initial tickets with FAST armor ticket [failure]"; > messages.log
    128 ${kinit} --fast-armor-cache=${acache} \
    129    --password-file=${objdir}/barpassword foo@$R 2>/dev/null && \
    130 	{ ec=1 ; eval "${testfailed}"; }
    131 
    132 echo "Checking for FAST avail (in the FAST acquired cache)"; > messages.log
    133 ${klist} --hidden | grep fast_avail > /dev/null || { exit 1; }
    134 
    135 echo "Getting service ticket"
    136 ${kgetcred} ${server}@${R} || { exit 1; }
    137 ${kdestroy}
    138 
    139 #
    140 # Use MIT client tools
    141 #
    142 
    143 mit=/usr/local/mitkerberos/bin
    144 
    145 if [ -f ${mit}/kinit ] ; then
    146    echo "Running MIT FAST tests"
    147 
    148     kinitpty=${objdir}/foopassword.rkpty
    149 cat > ${kinitpty} <<EOF
    150 expect Password
    151 password foo\n
    152 EOF
    153 
    154    echo "Acquire host ticket"; > messages.log
    155    ${rkpty} ${kinitpty} ${mit}/kinit -c ${acache} ${server}@${R} >/dev/null|| { exit 1; }
    156    (${aklist} | grep ${server} > /dev/null ) || { exit 1; }
    157 
    158    echo "Checking for FAST avail"; > messages.log
    159    ${aklist} --hidden | grep fast_avail > /dev/null || { exit 1; }
    160 
    161    echo "Using plain to get a initial ticket"; > messages.log
    162    ${rkpty} ${kinitpty} ${mit}/kinit -c ${cache} foo@${R} >/dev/null|| { exit 1; }
    163    (${klist} | grep foo > /dev/null ) || { exit 1; }
    164 
    165    echo "Using FAST to get a initial ticket"; > messages.log
    166    ${rkpty} ${kinitpty} ${mit}/kinit -c ${cache} -T ${acache} foo@${R} >/dev/null || { exit 1; }
    167    (${klist} | grep foo > /dev/null ) || { exit 1; }
    168 
    169    echo "Checking for FAST avail"; > messages.log
    170    ${klist} --hidden | grep fast_avail > /dev/null || { exit 1; }
    171 
    172    echo "Getting service ticket"; > messages.log
    173    ${mit}/kvno -c ${cache} ${server}@${R} || { exit 1; }
    174 
    175 fi
    176 
    177 
    178 echo "killing kdc (${kdcpid})"
    179 sh ${leaks_kill} kdc $kdcpid || exit 1
    180 
    181 trap "" EXIT
    182 
    183 exit $ec
    184